<?	
	/*
	 * Varga Bence
	 * lanny - at - freemail.hu
	 */
	 
	// kapott paramterek
	preg_match ("/.*\/([0-9a-z]{1,16})\/([0-9a-zA-z_\-]{1,64}\.[a-zA-z]{1,4})(\?([0-9a-f]{32})$|$)/", $GLOBALS["_SERVER"]["REQUEST_URI"], $found);
	$version = $found[1];
	$filename = $found[2];
	$auth = $found[4];
	
	// ha nem megfelelek az rtkek...
	if (!is_dir ($version) || !is_file ($version . "/.htconfig") || $version == "original")
		error ();
	
	// konfigurci olvassa
	$vdata = read_config ($version);
	
	// verzi jelszavas vdelme
	if ($vdata["passwd"] && md5 ($version . "/" . $filename . "/" . $vdata["passwd"]) != $auth)
		error ();
	
	// kp(ek) ellenrzse
	check_image ("original/" . $filename);
	if ($vdata["under"])
		check_image ($vdata["under"]);
	if ($vdata["over"])
		check_image ($vdata["over"]);
	
	// minimlisan szksges paramterek ellenrzse
	if (!$vdata["forcedw"] && !$vdata["maxw"] || !$vdata["forcedh"] && !$vdata["maxh"])
		error ();
	
	// plusz memria a konvertlshoz
	ini_set ("memory_limit", "36M");
	
	// verzi legyrtsa, mentse, kldse
	convert ($vdata, $version, $filename);
	
	
	function convert ($vdata, $version, $filename) {
		
		// eredeti kp betltse
		$image = load_image ("original/" . $filename);
		
		// eredeti mretek
		$w = imagesx ($image);
		$h = imagesy ($image);
		
		// j mret szmtsa
		if ($vdata["forcedw"] && !$vdata["forcedh"]) {
			
			// fix szlessg
			$new_width = $vdata["forcedw"];
			$new_height = min ($h * ($vdata["forcedw"] / $w), $vdata["maxh"]);
			
		} else if ($vdata["forcedh"] && !$vdata["forcedw"]) {
		
			// fix magassg
			$new_width = min ($w * ($vdata["forcedh"] / $h), $vdata["maxw"]);
			$new_height = $vdata["forcedh"];
			
		} else if ($vdata["forcedw"] && $vdata["forcedh"]) {
			
			// fix mretek
			$new_width = $vdata["forcedw"];
			$new_height = $vdata["forcedh"];
			
		} else {
		
			// laza mretezs (maximlis mretek)
			$ratio = min ($vdata["maxw"] / $w, $vdata["maxh"] / $h);
			$new_height = $h * $ratio;
			$new_width = $w * $ratio;
			
		}
		
		// cl filenv
		$pathname = $version . "/" . $filename;
		
		// minsg
		$qual = (int)$vdata["quality"] ? (int)$vdata["quality"] : "75";
		
		// filter alkalmazsa
		if ($vdata["filter"]) {
			$filter = config_array ($vdata["filter"]);
			imagefilter ($image, $filter[0], $filter[1], $filter[2], $filter[3]);
		}
		
		// tnyleges kpmveletek
		create_version ($image, $new_width, $new_height, $pathname, $qual, $vdata["under"], $vdata["over"], $vdata["bordersafe"], $vdata["attachment"]);
		
		// eredmny visszakldse a bngszbe
		header ('HTTP/1.1 200 OK');
		header ("Content-type: image/jpeg");
		readfile ($pathname);
	}
	
	function create_version ($image, $new_width, $new_height, $pathname, $qual, $under = false, $over = false, $bordersafe = false, $attachment = "") {
	
		// eredet kpmret
		$w = imagesx ($image);
		$h = imagesy ($image);
		
		// mretezs arnya
		$ratio = min ($w / $new_width, $h / $new_height);
		
		// ezzel a belltssal az eredeti kp 10%t (keret) eldobjuk
		if ($bordersafe)
			$ratio *= .9;
		
		// a fgglegesen kimarad rsz (szigor mretezs, azaz vgs esetn) milyen arnyban oszoljon meg a kp fltt s alatt,
		// azaz ll kpeknl (portr) megprbljuk nem levgni a fejet
		$partabove = ($h >= $w * 5 / 4) ? 4 : 2;
		
		// j kp objektum
		$im2 = imagecreatetruecolor ($new_width, $new_height);
		
		// httr zldre festse - egyrtelm legyen ha problma az tltsz (ttetsz) kp
		imagealphablending ($im2, true);
		$bg = imagecolorallocate ($im2, 0, 255, 0);
		imagefilledrectangle ($im2, 0, 0, $new_width, $new_height, $bg);
		
		//als rteg: httr
		if ($under) {
			$im3 = load_image ($under);
			copy_attached ($im2, $im3, $attachment);
			imagedestroy ($im3);
		}
		
		// mretezs + msols + vgs
		imagecopyresampled ($im2, $image, 0, 0, ($w - $new_width * $ratio) / 2, ($h - $new_height * $ratio) / $partabove, $new_width, $new_height, $new_width * $ratio, $new_height * $ratio);
		
		// fed rteg
		if ($over) {
			$im3 = load_image ($over);
			copy_attached ($im2, $im3, $attachment);
			imagedestroy ($im3);
		}
		
		// ments
		imagejpeg ($im2, $pathname, $qual);
		
		// tisztts
		imagecolordeallocate ($im2, $bg);
		imagedestroy ($im2);
	}
	
	
	function copy_attached ($dst, $src, $attachment) {
		// alap koordintk
		$dstx = 0;
		$dsty = 0;
		
		// mretek
		$srcw = imagesx ($src);
		$srch = imagesy ($src);
		$dstw = imagesx ($dst);
		$dsth = imagesy ($dst);
		
		// horizontlis (vzsintes) igazts
		if (preg_match ("/[cC]/", $attachment)) {
		
			// kzpre
			$dstx = (int)(($dstw - $srcw) / 2);
			
		} else if (preg_match ("/[rR]/", $attachment)) {
		
			// jobbra
			$dstx = $dstw - $srcw;
			
		}
		
		// vertiklis (fggleges) igazts
		if (preg_match ("/[mM]/", $attachment)) {
		
			// kzpre
			$dsty = (int)(($dsth - $srch) / 2);
			
		} else if (preg_match ("/[bB]/", $attachment)) {
		
			// jobbra
			$dsty = $dsth - $srch;
			
		}
		
		// msols a clkoordintkra
		imagecopy ($dst, $src, $dstx, $dsty, 0, 0, $srcw, $srch);
	}
	
	
	function check_image ($pathname) {
	
		// file lzetik?
		if (!is_file ($pathname))
			error ();
		
		// megfelel formtum?
		$info = getimagesize ($pathname);
		if (!in_array ($info[2], array (1, 2, 3)))
			error ();
	}
	
	
	function load_image ($pathname) {
	
		// file tipusa
		$info = getimagesize ($pathname);
		$type = $info[2];
		
		// betlts (tipus szerint)
		if ($type == 1) {
			return imagecreatefromgif ($pathname);
		} else if ($type == 2) {
			return imagecreatefromjpeg ($pathname);
		} else if ($type == 3) {
			return imagecreatefrompng ($pathname);
		} else {
			error ();
		}
	}
	
	// konfigurcis file (.config) olvassa
	function read_config ($dir) {
		$vdata = array ();
		
		$lines = file ($dir . "/.htconfig");
		foreach ($lines as $line) {
			$match = preg_match ("/([a-z0-9_]+):(.*)$/", trim ($line), $found);
			if ($match)
				$vdata[$found[1]] = trim ($found[2]);
		}
		
		return $vdata;
	}
	
	// tmb megfejtse a config filebl
	function config_array ($from) {
		$ex = explode (",", $from);
		foreach ($ex as $token) {
			if (($t = trim ($token))) {
				$ret[] = is_numeric ($t) ? $t : constant ($t);
			}
		}
		return $ret;
	}
	
	// egyszer 404 brmilyen hiba esetn
	function error ($msg = false) {
		header ('HTTP/1.1 404 Not Found');
		echo ('<html><title>404 Not Found</title><body><h1>Not Found</h1>Image conversion not possible.<br>');
		if ($msg) {
			trigger_error ($msg . ' "' . $GLOBALS["_SERVER"]["REQUEST_URI"] . '" "' . $GLOBALS["_SERVER"]["HTTP_REFERER"] . '"');
		}
		echo ('</body></html>');
		exit ();
	}
?>